<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Parsers/IDL/idlutil.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Parsers/IDL/idlutil.py</title>
<link href="../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Parsers/IDL/idlutil.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment"># -*- python -*-</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment">#                           Package   : omniidl</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># idlutil.py                Created on: 1999/10/27</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment">#			    Author    : Duncan Grisby (dpg1)</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment">#</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment">#    Copyright (C) 1999 AT&amp;T Laboratories Cambridge</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno">  8</span><span class="line"><span class="py-comment">#  This file is part of omniidl.</span></span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-comment">#</span></span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-comment">#  omniidl is free software; you can redistribute it and/or modify it</span></span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-comment">#  under the terms of the GNU General Public License as published by</span></span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-comment">#  the Free Software Foundation; either version 2 of the License, or</span></span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-comment">#  (at your option) any later version.</span></span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="py-comment">#</span></span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="py-comment">#  This program is distributed in the hope that it will be useful,</span></span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line"><span class="py-comment">#  but WITHOUT ANY WARRANTY; without even the implied warranty of</span></span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line"><span class="py-comment">#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span></span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line"><span class="py-comment">#  General Public License for more details.</span></span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line"><span class="py-comment">#</span></span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line"><span class="py-comment">#  You should have received a copy of the GNU General Public License</span></span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line"><span class="py-comment">#  along with this program; if not, write to the Free Software</span></span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line"><span class="py-comment">#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA</span></span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line"><span class="py-comment">#  02111-1307, USA.</span></span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line"><span class="py-comment">#</span></span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line"><span class="py-comment"># Description:</span></span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line"><span class="py-comment">#   </span></span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line"><span class="py-comment">#   Utility functions</span></span>
<a id="line28"></a><span class="lineno"> 28</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line"><span class="py-comment"># $Id: idlutil.py,v 1.9.2.4 2006/01/10 12:24:03 dgrisby Exp $</span></span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line"><span class="py-comment"># $Log: idlutil.py,v $</span></span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line"><span class="py-comment"># Revision 1.9.2.4  2006/01/10 12:24:03  dgrisby</span></span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line"><span class="py-comment"># Merge from omni4_0_develop pre 4.0.7 release.</span></span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line"><span class="py-comment">#</span></span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line"><span class="py-comment"># Revision 1.9.2.3  2005/07/21 09:54:59  dgrisby</span></span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line"><span class="py-comment"># Typo in docstring.</span></span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line"><span class="py-comment">#</span></span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line"><span class="py-comment"># Revision 1.9.2.2  2005/04/08 00:35:45  dgrisby</span></span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line"><span class="py-comment"># Merging again.</span></span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line"><span class="py-comment">#</span></span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line"><span class="py-comment"># Revision 1.9.2.1  2003/03/23 21:01:38  dgrisby</span></span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line"><span class="py-comment"># Start of omniORB 4.1.x development branch.</span></span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line"><span class="py-comment">#</span></span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line"><span class="py-comment"># Revision 1.5.2.6  2001/08/29 11:54:22  dpg1</span></span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line"><span class="py-comment"># Clean up const handling in IDL compiler.</span></span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line"><span class="py-comment">#</span></span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line"><span class="py-comment"># Revision 1.5.2.5  2001/08/15 10:31:23  dpg1</span></span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line"><span class="py-comment"># Minor tweaks and fixes.</span></span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line"><span class="py-comment">#</span></span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line"><span class="py-comment"># Revision 1.5.2.4  2001/06/13 11:28:22  dpg1</span></span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line"><span class="py-comment"># Proper omniidl support for wchar/wstring constants.</span></span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line"><span class="py-comment">#</span></span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line"><span class="py-comment"># Revision 1.5.2.3  2001/03/13 10:34:01  dpg1</span></span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line"><span class="py-comment"># Minor Python clean-ups</span></span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line"><span class="py-comment">#</span></span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line"><span class="py-comment"># Revision 1.5.2.2  2000/10/10 10:18:54  dpg1</span></span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line"><span class="py-comment"># Update omniidl front-end from omni3_develop.</span></span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line"><span class="py-comment">#</span></span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line"><span class="py-comment"># Revision 1.3.2.1  2000/08/29 15:20:29  dpg1</span></span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line"><span class="py-comment"># New relativeScope() function. New -i flag to enter interactive loop</span></span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line"><span class="py-comment"># after parsing</span></span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line"><span class="py-comment">#</span></span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line"><span class="py-comment"># Revision 1.3  1999/11/15 15:49:23  dpg1</span></span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line"><span class="py-comment"># Documentation strings.</span></span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line"><span class="py-comment">#</span></span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line"><span class="py-comment"># Revision 1.2  1999/11/01 20:18:30  dpg1</span></span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line"><span class="py-comment"># Added string escaping</span></span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line"><span class="py-comment">#</span></span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line"><span class="py-comment"># Revision 1.1  1999/10/29 15:47:07  dpg1</span></span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line"><span class="py-comment"># First revision.</span></span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line"><span class="py-comment">#</span></span>
<a id="line71"></a><span class="lineno"> 71</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line"><span class="py-string">&quot;&quot;&quot;Utility functions for IDL compilers</span></span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line"><span class="py-string"/></span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line"><span class="py-string">escapifyString()  -- return a string with non-printing characters escaped.</span></span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line"><span class="py-string">escapifyWString() -- return a wstring with non-printing characters escaped.</span></span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line"><span class="py-string">reprFloat()       -- return a string represenation of an IDL float type.</span></span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line"><span class="py-string">slashName()       -- format a scoped name with '/' separating components.</span></span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line"><span class="py-string">dotName()         -- format a scoped name with '.' separating components.</span></span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line"><span class="py-string">ccolonName()      -- format a scoped name with '::' separating components.</span></span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line"><span class="py-string">pruneScope()      -- remove common prefix from a scoped name.</span></span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line"><span class="py-string">relativeScope()   -- give a minimal name for one scope relative to another.&quot;&quot;&quot;</span></span>
<a id="line82"></a><span class="lineno"> 82</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line"><span class="py-keyword">import</span> string</span>
<a id="line84"></a><span class="lineno"> 84</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idlutil.html#slashName">slashName</a>(scopedName, our_scope=[]):</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">    <span class="py-string">&quot;&quot;&quot;slashName(list, [list]) -&gt; string</span></span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line"><span class="py-string"/></span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line"><span class="py-string">Return a scoped name given as a list of strings as a single string</span></span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line"><span class="py-string">with the components separated by '/' characters. If a second list is</span></span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line"><span class="py-string">given, remove a common prefix using pruneScope().&quot;&quot;&quot;</span></span>
<a id="line91"></a><span class="lineno"> 91</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">    pscope = pruneScope(scopedName, our_scope)</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">    <span class="py-keyword">return</span> string.join(pscope, <span class="py-string">&quot;/&quot;</span>)</span>
<a id="line94"></a><span class="lineno"> 94</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idlutil.html#dotName">dotName</a>(scopedName, our_scope=[]):</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">    <span class="py-string">&quot;&quot;&quot;dotName(list, [list]) -&gt; string</span></span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line"><span class="py-string"/></span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line"><span class="py-string">Return a scoped name given as a list of strings as a single string</span></span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line"><span class="py-string">with the components separated by '.' characters. If a second list is</span></span>
<a id="line100"></a><span class="lineno">100</span><span class="line"><span class="py-string">given, remove a common prefix using pruneScope().&quot;&quot;&quot;</span></span>
<a id="line101"></a><span class="lineno">101</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">    pscope = pruneScope(scopedName, our_scope)</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">    <span class="py-keyword">return</span> string.join(pscope, <span class="py-string">&quot;.&quot;</span>)</span>
<a id="line104"></a><span class="lineno">104</span>
<a id="line105"></a><span class="lineno">105</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idlutil.html#ccolonName">ccolonName</a>(scopedName, our_scope=[]):</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">    <span class="py-string">&quot;&quot;&quot;ccolonName(list, [list]) -&gt; string</span></span>
<a id="line107"></a><span class="lineno">107</span><span class="line"><span class="py-string"/></span>
<a id="line108"></a><span class="lineno">108</span><span class="line"><span class="py-string">Return a scoped name given as a list of strings as a single string</span></span>
<a id="line109"></a><span class="lineno">109</span><span class="line"><span class="py-string">with the components separated by '::' strings. If a second list is</span></span>
<a id="line110"></a><span class="lineno">110</span><span class="line"><span class="py-string">given, remove a common prefix using pruneScope().&quot;&quot;&quot;</span></span>
<a id="line111"></a><span class="lineno">111</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">    pscope = pruneScope(scopedName, our_scope)</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">    <span class="py-keyword">return</span> string.join(pscope, <span class="py-string">&quot;::&quot;</span>)</span>
<a id="line114"></a><span class="lineno">114</span>
<a id="line115"></a><span class="lineno">115</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idlutil.html#pruneScope">pruneScope</a>(target_scope, our_scope):</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">    <span class="py-string">&quot;&quot;&quot;pruneScope(list A, list B) -&gt; list</span></span>
<a id="line117"></a><span class="lineno">117</span><span class="line"><span class="py-string"/></span>
<a id="line118"></a><span class="lineno">118</span><span class="line"><span class="py-string">Given two lists of strings (scoped names), return a copy of list A</span></span>
<a id="line119"></a><span class="lineno">119</span><span class="line"><span class="py-string">with any prefix it shares with B removed.</span></span>
<a id="line120"></a><span class="lineno">120</span><span class="line"><span class="py-string"/></span>
<a id="line121"></a><span class="lineno">121</span><span class="line"><span class="py-string">  e.g. pruneScope(['A', 'B', 'C', 'D'], ['A', 'B', 'D']) -&gt; ['C', 'D']&quot;&quot;&quot;</span></span>
<a id="line122"></a><span class="lineno">122</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">    tscope = target_scope[:]</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">    i = 0</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">    <span class="py-keyword">while</span> len(tscope) &gt; 0 <span class="py-keyword">and</span>i &lt; len(our_scope) <span class="py-keyword">and</span>tscope[0] == our_scope[i]:</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">        <span class="py-keyword">del</span> tscope[0]</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">        i = i + 1</span>
<a id="line128"></a><span class="lineno">128</span><span class="line">    <span class="py-keyword">return</span> tscope</span>
<a id="line129"></a><span class="lineno">129</span>
<a id="line130"></a><span class="lineno">130</span><span class="line">_valid_chars = <span class="py-string">&quot;abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ&quot;</span><span class="py-string">&quot; 0123456789_!$%^&amp;*()-=+[]{};#:@~,./&lt;&gt;?|`&quot;</span></span>
<a id="line131"></a><span class="lineno">131</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">_valid_unichars = map(ord, list(_valid_chars))</span>
<a id="line133"></a><span class="lineno">133</span>
<a id="line134"></a><span class="lineno">134</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idlutil.html#escapifyString">escapifyString</a>(s):</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">    <span class="py-string">&quot;&quot;&quot;escapifyString(string) -&gt; string</span></span>
<a id="line136"></a><span class="lineno">136</span><span class="line"><span class="py-string"/></span>
<a id="line137"></a><span class="lineno">137</span><span class="line"><span class="py-string">Return the given string with any non-printing characters escaped.&quot;&quot;&quot;</span></span>
<a id="line138"></a><span class="lineno">138</span>
<a id="line139"></a><span class="lineno">139</span><span class="line">    <span class="py-keyword">global</span> _valid_chars</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">    l = list(s)</span>
<a id="line141"></a><span class="lineno">141</span><span class="line">    <span class="py-keyword">for</span> i <span class="py-keyword">in</span> range(len(l)):</span>
<a id="line142"></a><span class="lineno">142</span><span class="line">        <span class="py-keyword">if</span> l[i] <span class="py-keyword">not</span> <span class="py-keyword">in</span> _valid_chars:</span>
<a id="line143"></a><span class="lineno">143</span><span class="line">            l[i] = <span class="py-string">&quot;\\%03o&quot;</span> % ord(l[i])</span>
<a id="line144"></a><span class="lineno">144</span><span class="line">    <span class="py-keyword">return</span> string.join(l, <span class="py-string">&quot;&quot;</span>)</span>
<a id="line145"></a><span class="lineno">145</span>
<a id="line146"></a><span class="lineno">146</span>
<a id="line147"></a><span class="lineno">147</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idlutil.html#escapifyWString">escapifyWString</a>(l, escchar=<span class="py-string">&quot;u&quot;</span>):</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">    <span class="py-string">&quot;&quot;&quot;escapifyWString(int list) -&gt; string</span></span>
<a id="line149"></a><span class="lineno">149</span><span class="line"><span class="py-string"/></span>
<a id="line150"></a><span class="lineno">150</span><span class="line"><span class="py-string">Take a list of integers representing Unicode characters and return an</span></span>
<a id="line151"></a><span class="lineno">151</span><span class="line"><span class="py-string">ASCII string with all characters outside that range replaced with \\u</span></span>
<a id="line152"></a><span class="lineno">152</span><span class="line"><span class="py-string">escapes.&quot;&quot;&quot;</span></span>
<a id="line153"></a><span class="lineno">153</span>
<a id="line154"></a><span class="lineno">154</span><span class="line">    <span class="py-keyword">global</span> _valid_unichars</span>
<a id="line155"></a><span class="lineno">155</span><span class="line">    m = [None] * len(l)</span>
<a id="line156"></a><span class="lineno">156</span><span class="line">    <span class="py-keyword">for</span> i <span class="py-keyword">in</span> range(len(l)):</span>
<a id="line157"></a><span class="lineno">157</span><span class="line">        <span class="py-keyword">assert</span>(l[i] &lt;= 0xffff)</span>
<a id="line158"></a><span class="lineno">158</span><span class="line">        <span class="py-keyword">if</span> l[i] <span class="py-keyword">in</span> _valid_unichars:</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">            m[i] = chr(l[i])</span>
<a id="line160"></a><span class="lineno">160</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line161"></a><span class="lineno">161</span><span class="line">            m[i] = <span class="py-string">&quot;\\%s%04x&quot;</span> % (escchar, l[i])</span>
<a id="line162"></a><span class="lineno">162</span><span class="line">    <span class="py-keyword">return</span> string.join(m, <span class="py-string">&quot;&quot;</span>)</span>
<a id="line163"></a><span class="lineno">163</span>
<a id="line164"></a><span class="lineno">164</span>
<a id="line165"></a><span class="lineno">165</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idlutil.html#reprFloat">reprFloat</a>(f):</span>
<a id="line166"></a><span class="lineno">166</span><span class="line">    <span class="py-string">&quot;&quot;&quot;reprFloat(float) -&gt; string</span></span>
<a id="line167"></a><span class="lineno">167</span><span class="line"><span class="py-string"/></span>
<a id="line168"></a><span class="lineno">168</span><span class="line"><span class="py-string">Return the string representation of an IDL float type (float, double,</span></span>
<a id="line169"></a><span class="lineno">169</span><span class="line"><span class="py-string">long double), with enough precision to completely reconstruct the bit</span></span>
<a id="line170"></a><span class="lineno">170</span><span class="line"><span class="py-string">pattern.&quot;&quot;&quot;</span></span>
<a id="line171"></a><span class="lineno">171</span><span class="line">    <span class="py-comment"># *** Deal with long double</span></span>
<a id="line172"></a><span class="lineno">172</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">    s = <span class="py-string">&quot;%.17g&quot;</span> % f</span>
<a id="line174"></a><span class="lineno">174</span><span class="line">    <span class="py-keyword">if</span> string.find(s, <span class="py-string">&quot;.&quot;</span>) == -1:</span>
<a id="line175"></a><span class="lineno">175</span><span class="line">        s = s + <span class="py-string">&quot;.0&quot;</span></span>
<a id="line176"></a><span class="lineno">176</span><span class="line">    <span class="py-keyword">return</span> s</span>
<a id="line177"></a><span class="lineno">177</span>
<a id="line178"></a><span class="lineno">178</span>
<a id="line179"></a><span class="lineno">179</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idlutil.html#relativeScope">relativeScope</a>(fromScope, destScope):</span>
<a id="line180"></a><span class="lineno">180</span><span class="line">    <span class="py-string">&quot;&quot;&quot;relativeScope(fromScope, destScope) -&gt; list</span></span>
<a id="line181"></a><span class="lineno">181</span><span class="line"><span class="py-string"/></span>
<a id="line182"></a><span class="lineno">182</span><span class="line"><span class="py-string">Given two globally-scoped names, return a minimal scoped name list</span></span>
<a id="line183"></a><span class="lineno">183</span><span class="line"><span class="py-string">which identifies the destination scope, without clashing with another</span></span>
<a id="line184"></a><span class="lineno">184</span><span class="line"><span class="py-string">identifier. For example, given IDL:</span></span>
<a id="line185"></a><span class="lineno">185</span><span class="line"><span class="py-string"/></span>
<a id="line186"></a><span class="lineno">186</span><span class="line"><span class="py-string">  module M {</span></span>
<a id="line187"></a><span class="lineno">187</span><span class="line"><span class="py-string">    typedef short A;</span></span>
<a id="line188"></a><span class="lineno">188</span><span class="line"><span class="py-string">    typedef long  B;</span></span>
<a id="line189"></a><span class="lineno">189</span><span class="line"><span class="py-string"/></span>
<a id="line190"></a><span class="lineno">190</span><span class="line"><span class="py-string">    module N {</span></span>
<a id="line191"></a><span class="lineno">191</span><span class="line"><span class="py-string">      typedef string B;</span></span>
<a id="line192"></a><span class="lineno">192</span><span class="line"><span class="py-string">      interface I {</span></span>
<a id="line193"></a><span class="lineno">193</span><span class="line"><span class="py-string">        void op(in ::M::A x, in ::M::B y);</span></span>
<a id="line194"></a><span class="lineno">194</span><span class="line"><span class="py-string">      };</span></span>
<a id="line195"></a><span class="lineno">195</span><span class="line"><span class="py-string">    };</span></span>
<a id="line196"></a><span class="lineno">196</span><span class="line"><span class="py-string">  };</span></span>
<a id="line197"></a><span class="lineno">197</span><span class="line"><span class="py-string"/></span>
<a id="line198"></a><span class="lineno">198</span><span class="line"><span class="py-string">relativeScope([&quot;M&quot;, &quot;N&quot;, &quot;I&quot;], [&quot;M&quot;, &quot;A&quot;]) -&gt; [&quot;A&quot;]</span></span>
<a id="line199"></a><span class="lineno">199</span><span class="line"><span class="py-string">relativeScope([&quot;M&quot;, &quot;N&quot;, &quot;I&quot;], [&quot;M&quot;, &quot;B&quot;]) -&gt; [&quot;M&quot;, &quot;B&quot;]</span></span>
<a id="line200"></a><span class="lineno">200</span><span class="line"><span class="py-string"/></span>
<a id="line201"></a><span class="lineno">201</span><span class="line"><span class="py-string">If the only valid result is a globally-scoped name, the result list is</span></span>
<a id="line202"></a><span class="lineno">202</span><span class="line"><span class="py-string">prefixed with None:</span></span>
<a id="line203"></a><span class="lineno">203</span><span class="line"><span class="py-string"/></span>
<a id="line204"></a><span class="lineno">204</span><span class="line"><span class="py-string">  module O {</span></span>
<a id="line205"></a><span class="lineno">205</span><span class="line"><span class="py-string">    typedef short C;</span></span>
<a id="line206"></a><span class="lineno">206</span><span class="line"><span class="py-string">  };</span></span>
<a id="line207"></a><span class="lineno">207</span><span class="line"><span class="py-string">  module P {</span></span>
<a id="line208"></a><span class="lineno">208</span><span class="line"><span class="py-string">    module O {</span></span>
<a id="line209"></a><span class="lineno">209</span><span class="line"><span class="py-string">      interface J {</span></span>
<a id="line210"></a><span class="lineno">210</span><span class="line"><span class="py-string">        void op(in ::O::C z);</span></span>
<a id="line211"></a><span class="lineno">211</span><span class="line"><span class="py-string">      };</span></span>
<a id="line212"></a><span class="lineno">212</span><span class="line"><span class="py-string">    };</span></span>
<a id="line213"></a><span class="lineno">213</span><span class="line"><span class="py-string">  };</span></span>
<a id="line214"></a><span class="lineno">214</span><span class="line"><span class="py-string"/></span>
<a id="line215"></a><span class="lineno">215</span><span class="line"><span class="py-string">relativeScope([&quot;P&quot;, &quot;O&quot;, &quot;J&quot;], [&quot;O&quot;, &quot;C&quot;]) -&gt; [None, &quot;O&quot;, &quot;C&quot;]</span></span>
<a id="line216"></a><span class="lineno">216</span><span class="line"><span class="py-string"/></span>
<a id="line217"></a><span class="lineno">217</span><span class="line"><span class="py-string">If either scoped name does not exist, returns None.&quot;&quot;&quot;</span></span>
<a id="line218"></a><span class="lineno">218</span>
<a id="line219"></a><span class="lineno">219</span><span class="line">    <span class="py-keyword">import</span> _omniidl</span>
<a id="line220"></a><span class="lineno">220</span><span class="line">    <span class="py-keyword">return</span> _omniidl.relativeScopedName(fromScope, destScope)</span>
<a id="line221"></a><span class="lineno">221</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:16 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
